#ifndef HELPER_H
#define HELPER_H

//////////////////////////////
// Various helper functions //
//////////////////////////////

int find_label_partial(char **LabelList, int nblabels, const char * LabelToFind);
int find_label(char **LabelList, int nblabels, const char * LabelToFind);

#ifdef DEBUG
#define INIT_PARAM(POS)                                                \
  int     m_param, n_param, l_param;                                   \
  int     m_label, n_label, pos_label;                                 \
  int     m_tmp,   n_tmp,   l_tmp;                                     \
  char ** LabelList = NULL;                                            \
  GetRhsVar(POS, MATRIX_ORIENTED_TYPED_LIST_DATATYPE, &m_param, &n_param, &l_param); \
  DBGPRINTF("PARAM_IN: m_param = %d n_param = %d\n", m_param, n_param);\
  GetListRhsVar(POS, 1, MATRIX_OF_STRING_DATATYPE, &m_label, &n_label, &LabelList);
#else
#define INIT_PARAM(POS)                                   \
  int     m_param, n_param, l_param;                      \
  int     m_label, n_label, pos_label;                    \
  int     m_tmp,   n_tmp,   l_tmp;                        \
  char ** LabelList = NULL;                               \
  GetRhsVar(POS, MATRIX_ORIENTED_TYPED_LIST_DATATYPE, &m_param, &n_param, &l_param); \
  GetListRhsVar(POS, 1, MATRIX_OF_STRING_DATATYPE, &m_label, &n_label, &LabelList);
#endif

#ifdef DEBUG

#define GET_PARAM_INT(NAME, RESULT, DEFAULT, FOUND)			 \
  pos_label = find_label(LabelList, m_param, NAME);                      \
  FOUND = pos_label;                                                     \
  if (pos_label!=-1)							 \
    {									 \
      GetListRhsVar(PARAM_IN, pos_label+1, MATRIX_OF_INTEGER_DATATYPE, &m_tmp, &n_tmp, &l_tmp); \
      RESULT = *istk(l_tmp);						 \
      DBGPRINTF("DEBUG: Int - Parameter %s = %d\n", NAME, RESULT);	 \
    }									 \
  else									 \
    {									 \
      RESULT = DEFAULT;							 \
      DBGPRINTF("DEBUG: Int - Parameter %s = %d\n", NAME, RESULT);	 \
    }

#define GET_PARAM_VECT_INT(NAME,RESULT,SIZE,FOUND) \
  pos_label = find_label(LabelList, m_param, NAME);                      \
  FOUND = pos_label;                                                     \
  SIZE  = m_tmp*n_tmp;                                                   \
  if (pos_label!=-1)							 \
    {									 \
      GetListRhsVar(PARAM_IN, pos_label+1, MATRIX_OF_INTEGER_DATATYPE, &m_tmp, &n_tmp, &l_tmp); \
      RESULT = istk(l_tmp);						  \
      DBGPRINTF("DEBUG: Int - Parameter %s - length = %d\n", NAME, SIZE); \
    }									  \
  else									  \
    {									  \
      RESULT = NULL;							  \
      SIZE   = 0;                                                         \
      DBGPRINTF("DEBUG: Int - Parameter %s not found\n", NAME);	          \
    }

#define GET_PARAM_DOUBLE(NAME, RESULT, DEFAULT, FOUND)			 \
  pos_label = find_label(LabelList, m_param, NAME);			 \
  FOUND = pos_label;                                                     \
  if (pos_label!=-1)							 \
    {									 \
      GetListRhsVar(PARAM_IN, pos_label+1, MATRIX_OF_DOUBLE_DATATYPE, &m_tmp, &n_tmp, &l_tmp); \
      RESULT = *stk(l_tmp);						 \
      DBGPRINTF("DEBUG: Real - Parameter %s = %f\n", NAME, RESULT);	 \
    }									 \
 else									 \
   {									 \
     RESULT = DEFAULT;							 \
     DBGPRINTF("DEBUG: Real - Parameter %s = %f\n", NAME, RESULT);	 \
   }

#define GET_PARAM_VECT_DOUBLE(NAME,RESULT,SIZE,FOUND)                    \
  pos_label = find_label(LabelList, m_param, NAME);                      \
  FOUND = pos_label;                                                     \
  SIZE  = m_tmp*n_tmp;                                                   \
  if (pos_label!=-1)							 \
    {									 \
      GetListRhsVar(PARAM_IN, pos_label+1, MATRIX_OF_DOUBLE_DATATYPE, &m_tmp, &n_tmp, &l_tmp); \
      RESULT = stk(l_tmp);						  \
      DBGPRINTF("DEBUG: Int - Parameter %s - length = %d\n", NAME, SIZE); \
    }									  \
  else									  \
    {									  \
      RESULT = NULL;							  \
      SIZE   = 0;                                                         \
      DBGPRINTF("DEBUG: Int - Parameter %s not found\n", NAME);	          \
    }

#else

#define GET_PARAM_INT(NAME, RESULT, DEFAULT, FOUND)			 \
  pos_label = find_label(LabelList, m_param, NAME);                      \
  FOUND = pos_label;                                                     \
  if (pos_label!=-1)							 \
    {									 \
      GetListRhsVar(PARAM_IN, pos_label+1, MATRIX_OF_INTEGER_DATATYPE, &m_tmp, &n_tmp, &l_tmp); \
      RESULT = *istk(l_tmp);						 \
    }									 \
  else									 \
    {									 \
      RESULT = DEFAULT;							 \
    }

#define GET_PARAM_VECT_INT(NAME,RESULT,SIZE,FOUND) \
  pos_label = find_label(LabelList, m_param, NAME);                      \
  FOUND = pos_label;                                                     \
  SIZE  = m_tmp*n_tmp;                                                   \
  if (pos_label!=-1)							 \
    {									 \
      GetListRhsVar(PARAM_IN, pos_label+1, MATRIX_OF_INTEGER_DATATYPE, &m_tmp, &n_tmp, &l_tmp); \
      RESULT = istk(l_tmp);						  \
    }									  \
  else									  \
    {									  \
      RESULT = NULL;							  \
      SIZE   = 0;                                                         \
    }

#define GET_PARAM_DOUBLE(NAME, RESULT, DEFAULT, FOUND)			 \
  pos_label = find_label(LabelList, m_param, NAME);			 \
  FOUND = pos_label;                                                     \
  if (pos_label!=-1)							 \
    {									 \
      GetListRhsVar(PARAM_IN, pos_label+1, MATRIX_OF_DOUBLE_DATATYPE, &m_tmp, &n_tmp, &l_tmp); \
      RESULT = *stk(l_tmp);						 \
    }									 \
 else									 \
   {									 \
     RESULT = DEFAULT;							 \
   }

#define GET_PARAM_VECT_DOUBLE(NAME,RESULT,SIZE,FOUND)                    \
  pos_label = find_label(LabelList, m_param, NAME);                      \
  FOUND = pos_label;                                                     \
  SIZE  = m_tmp*n_tmp;                                                   \
  if (pos_label!=-1)							 \
    {									 \
      GetListRhsVar(PARAM_IN, pos_label+1, MATRIX_OF_DOUBLE_DATATYPE, &m_tmp, &n_tmp, &l_tmp); \
      RESULT = stk(l_tmp);						  \
    }									  \
  else									  \
    {									  \
      RESULT = NULL;							  \
      SIZE   = 0;                                                         \
    }

#endif

#endif
